from pandac.PandaModules import *


class Ode:
  def __init__(self):
    self.world = OdeWorld()
    self.world.setGravity(0, 0, -9.81)

    self.world.initSurfaceTable(1)
    self.world.setSurfaceEntry(0, 0, 0.1, 0.0, 1.0, 0.9, 0.00001, 0.0, 0.002)

    self.space = OdeHashSpace()
    self.space.setAutoCollideWorld(self.world)
    self.contactGroup = OdeJointGroup()
    self.space.setAutoCollideJointGroup(self.contactGroup)

    self.started = False
    def physics(task):
      if self.started:
        self.space.autoCollide()
        self.world.quickStep(globalClock.getDt())
        self.contactGroup.empty()
      else:
        self.started = True
      return task.cont

    taskMgr.add(physics,'physics',sort=100)

  def getSpace(self):
    return self.space

  def getWorld(self):
    return self.world

  def active(self):
    return self.started



